<template>
  <div>
    <q-list
      v-if="organicManureApplications && organicManureApplications.length"
      separator
    >
      <q-item
        v-for="organicManureApplication in organicManureApplications"
        :key="organicManureApplication.id"
        clickable
        v-ripple
        @click="onEditOrganicManureApplication(organicManureApplication)"
      >
        <q-item-section
          side
        >
          <q-icon
            name="las la-poo"
          />
        </q-item-section>

        <q-item-section class="text-body2">
          <q-item-label lines="1">
            {{ displayDate(organicManureApplication.applicationDate) }}
          </q-item-label>
          <q-item-label
            lines="1"
            caption
            class="row justify-between"
          >
            <div>{{ getAnimalCategoryLabel(organicManureApplication) }}</div>
            <div>
              {{ organicManureApplication.effluentQuantity }}
              <span> <translate>t/ha</translate></span>
            </div>
          </q-item-label>
        </q-item-section>

        <q-item-section
          side
          top
        >
          <q-icon
            name="las la-angle-right"
            class="q-mt-auto q-mb-auto"
          />
        </q-item-section>
      </q-item>
    </q-list>

    <q-card-actions
      align="right"
    >
      <q-btn
        outline
        color="primary"
        :disable="!hasAvailableApplications"
        @click="onNewOrganicManureApplication"
        class="q-mr-sm q-mb-sm"
      >
        <translate>
          Add application
        </translate>
      </q-btn>
    </q-card-actions>

    <q-dialog
      v-model="openEditDialog"
      persistent
    >
      <RequafertiOrganicManureApplicationEditForm
        :id="editedOrganicManureApplicationId"
        :initial-animal-category="editedOrganicManureApplicationAnimalCategory"
        :initial-organic-matter-type="editedOrganicManureApplicationOrganicMatterType"
        :initial-effluent-quantity="editedOrganicManureApplicationEffluentQuantity"
        :initial-nitrogen-content="editedOrganicManureApplicationNitrogenContent"
        :initial-application-date="editedOrganicManureApplicationDate"
        :organic-manure-animal-category-options="organicManureAnimalCategoryOptions"
        :organic-manure-application-combinations="organicManureApplicationCombinations"
        @on-save="onSaveOrganicManureApplication"
        @on-delete="onDeleteOrganicManureApplication"
        @on-cancel="onCancelOrganicManureApplication"
      />
    </q-dialog>
  </div>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { DateMixin } from 'src/mixins/DateMixin'
import RequafertiI18nMixin from 'src/pages/fieldbook/fertilization/algorithms/requaferti/mixins/RequafertiI18nMixin'
import RequafertiOrganicManureApplicationEditForm from 'src/pages/fieldbook/fertilization/algorithms/requaferti/components/RequafertiOrganicManureApplicationEditForm'

const MAX_APPLICATIONS = 3

export default {
  name: 'OrganicManureApplicationCard',
  mixins: [
    PlatformMixin,
    DateMixin,
    RequafertiI18nMixin
  ],
  components: {
    RequafertiOrganicManureApplicationEditForm
  },
  props: {
    initialOrganicManureApplications: {
      type: Array,
      required: true
    },
    organicManureAnimalCategoryOptions: {
      type: Array,
      required: true
    },
    organicManureApplicationCombinations: {
      type: Array,
      required: true
    }
  },
  emits: ['on-update'],
  data () {
    return {
      organicManureApplications: this.initialOrganicManureApplications || [],
      openEditDialog: false,
      editedOrganicManureApplication: null
    }
  },
  computed: {
    editedOrganicManureApplicationId () {
      return this.editedOrganicManureApplication?.id
    },
    editedOrganicManureApplicationAnimalCategory () {
      return this.editedOrganicManureApplication?.animalCategory || null
    },
    editedOrganicManureApplicationOrganicMatterType () {
      return this.editedOrganicManureApplication?.organicMatterType || null
    },
    editedOrganicManureApplicationEffluentQuantity () {
      return this.editedOrganicManureApplication?.effluentQuantity
    },
    editedOrganicManureApplicationNitrogenContent () {
      return this.editedOrganicManureApplication?.nitrogenContent
    },
    editedOrganicManureApplicationDate () {
      return this.editedOrganicManureApplication?.applicationDate
    },
    hasAvailableApplications () {
      return this.organicManureApplications.length < MAX_APPLICATIONS
    }
  },
  methods: {
    onEditOrganicManureApplication (organicManureApplication) {
      this.editedOrganicManureApplication = organicManureApplication
      this.openEditDialog = true
    },
    onNewOrganicManureApplication () {
      if (this.hasAvailableApplications) {
        this.openEditDialog = true
      }
    },
    onSaveOrganicManureApplication (organicManureApplication) {
      if (organicManureApplication.id) {
        this.onUpdateOrganicManureApplication(organicManureApplication)
      } else {
        this.onCreateOrganicManureApplication(organicManureApplication)
      }
    },
    onCreateOrganicManureApplication (organicManureApplication) {
      // add a temporary id to allow edition in the list before saving it
      this.organicManureApplications.push({ ...organicManureApplication, id: new Date().getTime() })
      this.openEditDialog = false
      this.editedOrganicManureApplication = null
      this.$emit('on-update', this.organicManureApplications)
    },
    onUpdateOrganicManureApplication (organicManureApplication) {
      for (let i = 0; i < this.organicManureApplications.length; i++) {
        if (this.organicManureApplications[i].id === organicManureApplication.id) {
          this.organicManureApplications.splice(i, 1, organicManureApplication)
          break
        }
      }
      this.openEditDialog = false
      this.editedOrganicManureApplication = null
      this.$emit('on-update', this.organicManureApplications)
    },
    onDeleteOrganicManureApplication (id) {
      for (let i = 0; i < this.organicManureApplications.length; i++) {
        if (this.organicManureApplications[i].id === id) {
          this.organicManureApplications.splice(i, 1)
          break
        }
      }
      this.openEditDialog = false
      this.editedOrganicManureApplication = null
      this.$emit('on-update', this.organicManureApplications)
    },
    onCancelOrganicManureApplication () {
      this.openEditDialog = false
      this.editedOrganicManureApplication = null
    },
    getAnimalCategoryLabel (application) {
      return application.animalCategory?.[this.getRequafertiI18NFieldName('libelle')]
    }
  }
}

</script>
